#!/bin/sh
#   Copyright (c) 2010 digitalSTROM.org, Zurich, Switzerland
#
#   Author: Sergey 'Jin' Bostandzhyan <jin@mediatomb.cc>
#
#   This file is part of digitalSTROM Server.
#
#   netinfo.sh is free software: you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation, either version 3 of the License, or
#   (at your option) any later version.
#
#   netinfo.sh is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this file. If not, see <http://www.gnu.org/licenses/>.

# source common functions
. ./errlib.sh
. ./jsonlib.sh

json_out() {
    echo -n "{ \"success\": true, \"code\": $ERR_OK, \"message\": \"OK\", "
    echo -n "\"data\": { \"dssrunning\": $1, \"dssuptime\": \"$2\", "
    echo -n "\"dss11uptime\": $3, \"dss11days\": $4, \"dss11hours\": $5, "
    echo    "\"dss11minutes\": $6, \"dss11seconds\": $7 } }"
}

echo "Content-Type: application/json"
echo ""

DSS_RUNNING="false"
DSS_UPTIME=""
DSS11_UPTIME=0
DAYS=
HOURS=
MINUTES=
SECONDS=

DSS_STAT=`cat /etc/runit/dss/supervise/stat`
if [[ "$DSS_STAT" = "run" ]]; then
    DSS_PID=`pidof dss`
    [[ -n "$DSS_PID" ]] && DSS_RUNNING="true"
    DSS_UPTIME=`ls -ld /etc/runit/dss/supervise/stat | awk '{ print $6 " " $7 ", " $8}'`
fi

UPTIME=`cat /proc/uptime | cut -d " " -f 1 | cut -d "." -f 1`
if [[ -n "$UPTIME" ]]; then
    DSS11_UPTIME=$UPTIME
    DAYS=$(($UPTIME / 86400))
    HOURS=$(( $(($UPTIME / 3600)) - $(($DAYS * 24)) ))
    MINUTES=$(($(($UPTIME / 60)) - $(($DAYS * 1440)) - $(($HOURS * 60)) ))
    SECONDS=$(($UPTIME % 60))
fi

json_out "$DSS_RUNNING" "$DSS_UPTIME" "$DSS11_UPTIME" "$DAYS" "$HOURS" "$MINUTES" "$SECONDS"

